local bindMode = false
local find = string.find



local function setBindframeTooltip(bindFrame, button)

	GameTooltip:SetOwner(bindFrame, "ANCHOR_RIGHT")

	GameTooltip:AddLine(format("Extra Button Number "..button.index ).."|r", 1.0, 1.0, 1.0)
	if (button.type == "extra") then
		GameTooltip:AddLine("KeyBinding: " .. Amf.settings.extraBindings[button.index], 0.0, 1.0, 0.0)
	else
		GameTooltip:AddLine("KeyBinding: " .. Amf.settings.bindings[button.index], 0.0, 1.0, 0.0)
	end
	GameTooltip:Show()
end



function Amf.BindFrame_OnLoad(self)

	self:EnableMouseWheel(true)
	self:RegisterForClicks("AnyUp")
	self:RegisterForClicks("AnyDown")
	self:Hide()
	self:SetFrameLevel(6)
	self.action = "action"

	self.select:SetPoint("TOPLEFT", self:GetParent(), "TOPLEFT")
	self.select:SetPoint("BOTTOMRIGHT", self:GetParent(), "BOTTOMRIGHT")

end

function Amf.BindFrame_OnLeave(self, button)

	self.select:Hide()
	self.UpdateTooltip = nil
	GameTooltip:Hide()
end
function Amf.BindFrame_OnEnter(self, button)

	self.select:Show()
	setBindframeTooltip(self, button)
end

function Amf.BindFrame_OnUpdate(self, elapsed)

	if (self:IsMouseOver()) then
		self:EnableKeyboard(true)
	else
		self:EnableKeyboard(false)
	end
end
local function ApplyBindings(key,button)
	local hotkey
	local btn
	if (button.type == "extra") then
		hotkey = _G[button:GetName().."HotKey"];
		Amf.settings.extraBindings[button.index] = key;
		button:SetAttribute("hotkeys", key);
		hotkey:SetText(key);
	else
		Amf.settings.bindings[button.index] = key;
		for i=1,Amf.NUM_ACTIONBAR do
			btn = Amf.Buttons[button.index + ((i-1) * Amf.NUM_ACTIONBAR_BUTTONS)];
			hotkey = _G[btn:GetName().."HotKey"];
			btn:SetAttribute("hotkeys", key);
			hotkey:SetText(key);
		end
	end
	
	
	SetBindingClick(key, button:GetName());
	
	
end


function Amf.BindFrame_OnKeyDown(self, key, button)

	if (find(key,"ALT") or find(key,"SHIFT") or find(key,"CTRL") or find(key, "PRINTSCREEN")) then
		return
	end
	local btn;
	if (key == "ESCAPE") then
		key = "";
	else	
		for index=1, Amf.NUM_ACTIONBAR_BUTTONS  do
			if key == Amf.settings.bindings[index] then
				for i=1, Amf.NUM_ACTIONBAR do
					btn = Amf.Buttons[index + ((i-1) * Amf.NUM_ACTIONBAR_BUTTONS)];
					ApplyBindings("", btn);
				end
					btn = Amf.Buttons[index+120]
					ApplyBindings("", btn);
			end
		end
		for i=1,Amf.NUM_ACTIONEXTRA_BUTTONS do
			if key == Amf.settings.extraBindings[i] then
				btn = Amf.ExtraButtons[i]
				ApplyBindings("", btn);
			end
		end
	end
	ApplyBindings(key, button);
	



end

