local _,player = UnitClass("player");
AmfSavedData = {};
local editmode, bindmode = false, false;

function Amf.HideBlizzard()
	local noop = Multibar_EmptyFunc
	MultiActionBar_Update = noop
	MultiActionBar_UpdateGrid = noop
	ShowBonusActionBar = noop

	if not _G['VehicleSeatIndicator']:IsUserPlaced() then
		_G['VehicleSeatIndicator']:SetPoint("TOPRIGHT", MinimapCluster, "BOTTOMRIGHT", 0, -13)
	end

	UIPARENT_MANAGED_FRAME_POSITIONS['MultiBarRight'] = nil
	UIPARENT_MANAGED_FRAME_POSITIONS['MultiBarLeft'] = nil
	UIPARENT_MANAGED_FRAME_POSITIONS['MultiBarBottomLeft'] = nil
	UIPARENT_MANAGED_FRAME_POSITIONS['MultiBarBottomRight'] = nil
	UIPARENT_MANAGED_FRAME_POSITIONS['MainMenuBar'] = nil
	UIPARENT_MANAGED_FRAME_POSITIONS['ShapeshiftBarFrame'] = nil
	UIPARENT_MANAGED_FRAME_POSITIONS['PossessBarFrame'] = nil
	UIPARENT_MANAGED_FRAME_POSITIONS['PETACTIONBAR_YPOS'] = nil
	
	MainMenuBar:SetPoint("BOTTOM", 0, -200)
	MainMenuBar:UnregisterAllEvents()
	MainMenuBar:Hide()

	MainMenuBarArtFrame:UnregisterEvent('PLAYER_ENTERING_WORLD')
	MainMenuBarArtFrame:UnregisterEvent('ACTIONBAR_PAGE_CHANGED')
	MainMenuBarArtFrame:UnregisterEvent('ADDON_LOADED')
	MainMenuBarArtFrame:UnregisterEvent('UNIT_ENTERING_VEHICLE')
	MainMenuBarArtFrame:UnregisterEvent('UNIT_ENTERED_VEHICLE')
	MainMenuBarArtFrame:UnregisterEvent('UNIT_EXITING_VEHICLE')
	MainMenuBarArtFrame:UnregisterEvent('UNIT_EXITED_VEHICLE')
	MainMenuBarArtFrame:Hide()

	MainMenuExpBar:UnregisterAllEvents()
	MainMenuExpBar:Hide()

	ShapeshiftBarFrame:UnregisterAllEvents()
	ShapeshiftBarFrame:Hide()

	BonusActionBarFrame:UnregisterAllEvents()
	BonusActionBarFrame:Hide()

	PossessBarFrame:UnregisterAllEvents()
	PossessBarFrame:Hide()

	hooksecurefunc('TalentFrame_LoadUI', function()
		PlayerTalentFrame:UnregisterEvent('ACTIVE_TALENT_GROUP_CHANGED')
	end)
end
function Amf.CreateExtraBar()
	local button;
	
	for i=1,Amf.NUM_ACTIONEXTRA_BUTTONS do
		button = Amf.CreateExtraActionButton(i,108+i)
		
		if(i == 1) then
			button:SetPoint("TOPLEFT", _G["ExtraBarFrame"], "TOPLEFT", 10, -10);
		elseif(i == 4) then
			button:SetPoint("TOP", _G["ExtraActionButton1"], "BOTTOM", 0, -6);
		elseif(i== 7) then
			button:SetPoint("TOP", _G["ExtraActionButton4"], "BOTTOM", 0, -6);
				elseif(i== 10) then
			button:SetPoint("TOP", _G["ExtraActionButton7"], "BOTTOM", 0, -6);
		else
			button:SetPoint("LEFT", _G["ExtraActionButton"..(i-1)], "RIGHT", 6, 0);
		end
	end

end


function Amf.CreateBar(barNum, type) 
	local button;
	local upArrow = _G["AmfUpArrow"];
	upArrow:ClearAllPoints();
	for i=1, Amf.NUM_ACTIONBAR_BUTTONS do
	
		button = Amf.ActionButton_CreateButton(barNum,i, type );
		if (i == 1) then
			button:SetPoint("TOPLEFT", _G["MainBarFrame"], "TOPLEFT", 10, -10);
		elseif (i == 2) then   
			button:SetPoint("LEFT", _G["Bar"..barNum.."ActionButton1"], "RIGHT", 6, 0);
			upArrow:SetPoint("LEFT", _G["Bar"..barNum.."ActionButton2"], "RIGHT", 6, 0);
		elseif(i==3) then
			button:SetPoint("LEFT", _G["AmfUpArrow"], "RIGHT", 6, 0);
		elseif(i == 5) then
			button:SetPoint("TOP", _G["Bar"..barNum.."ActionButton1"], "BOTTOM", 0, -6);
		elseif(i == 6) then
			button:SetPoint("LEFT", _G["AmfRightArrow"], "RIGHT", 6, 0);
		elseif(i==7) then
			button:SetPoint("TOP", _G["Bar"..barNum.."ActionButton5"], "BOTTOM", 0, -6);
		else
			button:SetPoint("LEFT", _G["Bar"..barNum.."ActionButton"..(i-1)], "RIGHT", 6, 0);
		end

	end
	

end
function editingmode()

	if (bindmode) then bindingmode() end
	
	local dragFrame = _G["DragFrame"];
	local edragFrame = _G["ExtraDragFrame"];
	local mainFrame = _G["MainBarFrame"];
	local extraFrame = _G["ExtraBarFrame"];
	local editFrame = _G["AmfbarEditor"];
	
	if (editmode) then 
		dragFrame:SetScript("OnDragStart", nil);
		dragFrame:SetScript("OnDragStop", nil);
		
		edragFrame:SetScript("OnDragStart", nil);
		edragFrame:SetScript("OnDragStop", nil);
		
		dragFrame:SetBackdropColor(0,0,1,0);
		
		edragFrame:SetBackdropColor(0,0,1,0);
		
		mainFrame:SetBackdropColor(0,0,1,0);
		mainFrame.resize:Hide();
		
		extraFrame:SetBackdropColor(0,0,1,0);
		extraFrame.resize:Hide();
		editFrame:Hide();
		editmode = false;
	else
		dragFrame:SetScript("OnDragStart", dragFrame.StartMoving);
		dragFrame:SetScript("OnDragStop", dragFrame.StopMovingOrSizing);
		
		edragFrame:SetScript("OnDragStart", edragFrame.StartMoving);
		edragFrame:SetScript("OnDragStop", edragFrame.StopMovingOrSizing);
		
		dragFrame:SetBackdropColor(0,0,1,1);
		mainFrame:SetBackdropColor(0,0,1,.5);
		mainFrame.resize:Show();
		
		edragFrame:SetBackdropColor(0,0,1,1);
		extraFrame:SetBackdropColor(0,0,1,.5);
		extraFrame.resize:Show();
		
		editFrame:Show();
		editmode = true;
	
	end
end

function bindingmode()
	
	
	if (editmode) then editingmode() end

	if (bindmode) then 

		bindmode = false
		for k,v in pairs(Amf.Buttons) do
			v.bindframe:Hide()
			v.bindframe:SetFrameStrata("LOW")
			Amf.ActionButton_HideGrid (v)
			v.bindframe.bindmode = false
			
		end	
		for k,v in pairs(Amf.ExtraButtons) do
			v.bindframe:Hide()
			v.bindframe:SetFrameStrata("LOW")
			Amf.ActionButton_HideGrid (v)
			v.bindframe.bindmode = false
		end	
		collectgarbage()
	else
		bindmode = true
		
		for _,v in pairs(Amf.Buttons) do
			v.bindframe:SetFrameStrata("HIGH")
			Amf.ActionButton_ShowGrid (v)
			v.bindframe:Show()	
		end
		for _,v in pairs(Amf.ExtraButtons) do
			v.bindframe:SetFrameStrata("HIGH")
			Amf.ActionButton_ShowGrid (v)
			v.bindframe:Show()	
		end
	end

end

local function slashHandler(msg, editbox)
	if (InCombatLockdown()) then return end 

	if msg == 'edit' then
		
		editingmode();
	
	elseif msg == 'bind' then 
	
		bindingmode();
		
	end
end


local function controlOnEvent(self, event, addon)
local _, class = UnitClass("player")

	if (event == "ADDON_LOADED" ) then

		if (addon == "Amfn52teBar") then
		
			Amf.HideBlizzard()
			defualts = {
				scale = 1,
				states = {
					["[mod:alt]"] = 1,
					["[mod:ctrl]"] = 1,
					["[mod:shift]"] = 1,
					["[bonusbar:5]"] = 13
				},
		
				bindings = {
					[1] = "1",
					[2] = "2",
					[3] = "3",
					[4] = "4",
					[5] = "5",
					[6] = "6",
					[7] = "7",
					[8] = "8",
					[9] = "9",
					[10] = "0",
				},
				extraBindings = {
					[1] = "F1",
					[2] = "F2",
					[3] = "F3",
					[4] = "F4",
					[5] = "F5",
					[6] = "F6",
					[7] = "F7",
					[8] = "F8",
					[9] = "F9",
					[10] = "F10",
					[11] = "F11",
					[12] = "F12",
				}
			}
			
			if ( class == "WARRIOR" ) then
				defualts.states["[bonusbar:1]"] = 1
				defualts.states["[bonusbar:2]"] = 1
				defualts.states["[bonusbar:3]"] = 1
			elseif ( class == "DRUID") then 
				defualts.states["[bonusbar:1]"] = 3
				defualts.states["[bonusbar:1,stealth]"] = 4
				defualts.states["[bonusbar:3]"] = 3
				defualts.states["[bonusbar:4]"] = 6
			elseif ( class == "ROGUE") then
				defualts.states["[bonusbar:1]"] = 6
				defualts.states["[form:3]"] = 6
			elseif ( class == "PRIEST" ) then
				defualts.states["[bonusbar:1]"] = 6
			elseif ( class =="WARLOCK") then
				defualts.states["[form:2]"] = 1
			end
			
			if (AmfSavedData.settings == nil) then
				AmfSavedData.settings = defualts
			end
			Amf.settings = AmfSavedData.settings
			
			for i=1,Amf.NUM_ACTIONBAR do
			Amf.CreateBar(i, "action");
			end
			Amf.CreateExtraBar()
			Amf.CreateBar(13, "process");	
			Amf.CreateBarSliders();
			
			_G["MainBarFrame"]:SetScale(Amf.settings.scale);
			_G["DragFrame"]:SetScale(Amf.settings.scale);
			
			Amf.UpdateRegisterStateDriver()
			
			SlashCmdList["AMFN52"] = slashHandler
			SLASH_AMFN521 = "/amfn52"
			
		end
	elseif (event == "PLAYER_ENTER_COMBAT") then
	
		if (editmode) then editingmode() end
		if (bindmode) then bindingmode() end
	
	end
end


function Amf.ScaleBtn_OnMouseDown(icon, button)
	local scalingFrame = icon:GetParent();
	scalingFrame.oldScale = scalingFrame:GetScale();
	icon.oldCursorX, icon.oldCursorY = GetCursorPosition(UIParent);
	scalingFrame.oldX = scalingFrame:GetLeft();
	scalingFrame.oldY = scalingFrame:GetTop();
	icon:SetScript("OnUpdate", Amf.Bar_SizeUpdate);
end

function Amf.Bar_SizeUpdate(icon)
	local uiScale = UIParent:GetScale();
	local scalingFrame = icon:GetParent();
	local cursorX, cursorY = GetCursorPosition(UIParent);
	local dragFrame = _G[icon.dragFrame];

	local newXScale = scalingFrame.oldScale * (cursorX/uiScale - scalingFrame.oldX*scalingFrame.oldScale) / (icon.oldCursorX/uiScale - scalingFrame.oldX*scalingFrame.oldScale) ;
	local newYScale = scalingFrame.oldScale * (cursorY/uiScale - scalingFrame.oldY*scalingFrame.oldScale) / (icon.oldCursorY/uiScale - scalingFrame.oldY*scalingFrame.oldScale) ;
	local newScale = max(0.6, newXScale, newYScale);
	scalingFrame:SetScale(newScale);
	dragFrame:SetScale(newScale);
	Amf.settings.scale = newScale;
	local newX = scalingFrame.oldX * scalingFrame.oldScale / newScale;
	local newY = scalingFrame.oldY * scalingFrame.oldScale / newScale;
	dragFrame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", newX, newY);
	scalingFrame:SetPoint("TOPLEFT", dragFrame, "BOTTOMLEFT", 0, 10);
end

function Amf.UpdateRegisterStateDriver()
	local header = ""
	UnregisterStateDriver(_G["MainBarFrame"],"state");
	
	for _,h in pairs(Amf.conditions) do
		for k,v in pairs(Amf.settings.states) do
			if (h == k) then
				header =  header.. k .. " bar" .. v ..";";
				break;
			end
		end
	end
	SecureHandler_OnLoad(_G["MainBarFrame"]);
	RegisterStateDriver(_G["MainBarFrame"], "state", header.. "bar1")
end

function Amf.ScaleBtn_OnMouseUp(icon)
icon:SetScript("OnUpdate", nil)
end

	
	


local frame = CreateFrame("Frame", nil, UIParent)
frame:SetScript("OnEvent", controlOnEvent)
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("PLAYER_ENTER_COMBAT")
